      program draw2d
c
c To draw x-z profile of Vs estimated by MASW
c
      parameter(nmax0=1000,nlayer0=10,ncmp0=500) 
      character filen*80
      real*4 v(nlayer0,ncmp0),d(nlayer0,ncmp0),x(nmax0,ncmp0)
      character cmpnum*3,com1*45
      data ddep/0.1/               ! depth interval in (m)
      filen='./maswkf/prm/draw2d.prm'     ! parameter file
      write(6,*)filen
      open(11,file=filen,status='old')
c min. & max. dep & vel for drawing
      read(11,*)dep_min,dep_max,v_min,v_max,n_reverse
      nmax=int((dep_max-dep_min)/ddep+.5)  
      close(11)
      filen='./maswkf/prm/geometry.prm'
      open(11,file=filen,status='old')
      read(11,'(a45)')com1
      close(11)
c
      filen='./maswkf/data/geometry/x_cmp.dat'     ! parameter file
      write(6,*)filen
      open(11,file=filen,status='old')
      read(11,*)x_1              ! 1st CMP position, CMP interval
      read(11,*)x_2              ! 1st CMP position, CMP interval
      x1=x_1
      dx=x_2-x_1
      close(11)
c
      filen='./maswkf/prm/disp_sma1_3.prm'     ! parameter file
      write(6,*)filen
      open(11,file=filen,status='old')
      do ii=1,7                                ! skip 7 lines
       read(11,*)
      enddo
      read(11,*)ncmps,ncmpe,ncmpd  ! CMP numberings(start, end, interval)
      close(11)
c
      do icmp=ncmps,ncmpe,ncmpd
c
       if(icmp.lt.10) then
        write(cmpnum,'(a2,i1)')'00',icmp
       else if(icmp.lt.100) then
        write(cmpnum,'(a1,i2)')'0',icmp
       else if(icmp.lt.1000) then
        write(cmpnum,'(i3)')icmp
       endif
c all vel_cal???.dat files are under ./maswkf/data/structure
       filen='./maswkf/data/structure/vel_cal'//cmpnum//'.dat'
c      write(6,*) filen
       open(8,file=filen,status='old')
       read(8,*)                      ! skip one line
       read(8,*)nlayer,rmd
       nlayer=nlayer+1
       do ilayer=1,nlayer
        read(8,'(i2,4f16.1)')idum,th,ro,vp,vs
        v(ilayer,icmp)=vs             ! roh & vp ignored
        d(ilayer,icmp)=th             ! depth layer's bottom
       enddo
       if(d(nlayer,icmp).lt.rmd) d(nlayer,icmp)=rmd
       close(8)
c+++++++++
       do n=1,nmax
c
        dep=real(n)*ddep+dep_min
        if(dep.lt.d(1,icmp)) then
         x(n,icmp)=v(1,icmp)
        else
         do ilayer=1,nlayer
          if(dep.lt.d(ilayer,icmp).and.dep.ge.d(ilayer-1,icmp)) then
           x(n,icmp)=v(ilayer,icmp)
c          write(6,'(i8,2f9.2)')n,dep,x(n,icmp)
           go to 20
          endif
         enddo
   20    continue       ! write(6,'(i8,2f9.5)')n,dep,x(n,icmp)
        endif    
c
       enddo
c
      enddo
c output:data
      filen='./maswkf/data/structure/draw2d.dat'
c     write(6,*)filen
      open(22,file=filen,status='unknown')
      write(22,'(a1,7x,a8,2(8x,a8))')
     *        '#','Distance','  Depth ','  Vs    '
       do icmp=ncmps,ncmpe,ncmpd
        dist=x1+real(icmp-ncmps)*dx
        do n=nmax,1,-1
         dep=real(n)*ddep
         write(22,'(3(8x,f8.3))') dist,dep,x(n,icmp)
c         write(6,'(3(8x,f8.3))') dist,dep,x(n,icmp)
        enddo
        write(22,*)
       enddo
       close(22)
c output:drawing using GNUPLOT
      filen='./maswkf/prm/gnuplt_script/draw2d.plt'
      open(1,file=filen,status='unknown')
      write(1,*)'reset'
      write(1,*)'unset key'
      write(1,*)'# Graph title'
      write(1,*)'set title "'//com1(1:45)//'"'
      write(1,*)'# Horizontal axis: label & range'
      write(1,*)'set xlabel "Distance (m)"'
      write(1,*)'set grid'
      if(n_reverse.ge.0) then
       write(1,*)'set xrange [0.0:',dist,']'
      else if(n_reverse.lt.0) then
       write(1,*)'set xrange [',dist,': 0.0]'
      endif
      write(1,*)'# Verical axis: label & range'
      write(1,*)'set ylabel "Depth (m)"'
      write(1,*)'set yrange [',dep_max,':',dep_min,']'
      write(1,*)'# Vs determined '
      write(1,*)'set zrange [',v_min,':',v_max,']'
      write(1,*)'set pm3d map'
      write(1,*)'set multiplot'
      write(1,*)'splot "./maswkf/data/structure/draw2d.dat"'
      write(1,*)'unset multiplot'
c
      write(1,*)'set terminal postscript color enhanced'
      write(1,*)
     * 'set output "./maswkf/data/structure/fig/draw2d.ps"'
      write(1,*)'reset'
      write(1,*)'unset key'
      write(1,*)'# Graph title'

      write(1,*)'set title "'//com1(1:45)//'"'
      write(1,*)'# Horizontal axis: label & range'
      write(1,*)'set xlabel "Distance (m)"'
      write(1,*)'set grid'
      if(n_reverse.ge.0) then
       write(1,*)'set xrange [0.0:',dist,']'
      else if(n_reverse.lt.0) then
       write(1,*)'set xrange [',dist,': 0.0]'
      endif
      write(1,*)'# Verical axis: label & range'
      write(1,*)'set ylabel "Depth (m)"'
      write(1,*)'set yrange [',dep_max,':',dep_min,']'
      write(1,*)'# Vs determined '
      write(1,*)'set zrange [',v_min,':',v_max,']'
      write(1,*)'set pm3d map'
      write(1,*)'set multiplot'
      write(1,*)'splot "./maswkf/data/structure/draw2d.dat"'
      write(1,*)'unset multiplot'
      write(1,*)'set output'
      write(1,*)'set terminal x11'
      close(1)
c
      stop
      end
