      Program masw2_1
c Multi-Channel Analysis of Surface Wave generated by an artificial 
c shot and measured along a line
c
c Multi Shot - Multi CMP version
c
c Make Common Shot Gather files Only
c Use masw2cmp.for after this program.
c 
c Input data file should listed from shot point side in the parameter file
c 24 channels
c Phase velocity is determined at Common Mid Points from the middle of 1ch and 2ch 
c to that of 23ch and 24ch (or 11chand 12ch).
c
c 1 <==Fixed               :(=1:CMP gather, =2:Phase Velocity, =3: Both)
c 4.0 20.0 0.001           :fmin,fmax,dt
c 50. 300. 1. 4. 23.       :vmin,vmax,dv,rrmin,rrmax
c 24  23. 1.0 2048         :# of channel for a Common Shot Gather,length of measurement line,dx,nn
c sxbf7002.dat   -0.5   0. :Input File Name (Common Shot Gather),x(shot),x(1ch)
c sxbf7003.dat    0.5   0.   
c sxbf7004.dat    1.5   0.    
c continue...               These should be listed from the shot point side
c (fmin, fmax)             :Frequency range of analysis
c dt                       :Sampling interval
c (vmin,vmax,dv)           :Velocity range and interval for analysis
c rrmin                    :Minimum interstation spacing for analysis. Used to exclude 
c                           saturated traces close to shot point
c rrmax                    :Maximum interstation spacing for analysis. Used to exclude
c                           the traces of which S/N ratio is not enough high.
c
c    Output the power spectra of all channels. Pay attention to the channels close to the shot point.
c    Eliminate them if they show a very different power spectra from other channels.
c
c Output files
c  CMP_**.dat: Common Shot Gather files
c  crs_cf.dat: Stacked seismographs in the velocity-frequency domain for CMPCC
c  coh_pk.dat: Peaks extracted from Stacked seismographs in the velocity-frequency domain
c  ********.dat: Output file of given name that includes the dispersion curve
c
      parameter(nn0=8192,ncmp0=500,nch0=24,nbin0=5,
     *                                nfile0=100,nvl0=2000,lmax0=500)
      complex c0,ci,cf(nn0),cg(nn0),ch(nn0),csum
      real  x(nn0,nch0),fr(nn0),f(nn0),g(nn0),rr(nch0),
     *      cr(nn0,ncmp0,nch0),cq1(nn0,ncmp0),
     *      cq2(nn0,ncmp0),x_shot(nfile0),x_sta(0:nch0,nfile0) 
      integer nb_ch(ncmp0,nch0,nfile0),nf_ch(ncmp0,nch0,nfile0),
     *        nstack(ncmp0,nch0),mstack(ncmp0,nch0)
      character filen*80,cform*20,cmethod*5,filnam(nfile0)*12,cfrm*10
      character cdrv*2,cwkf*9,cunit*5,comment*70
      data cdrv/'./'/
c     character cdrv*3,cwkf*10  
c     data cdrv/'../'/ 
	data cmethod/'CMPCC'/ N_CF_DOMAIN/0/
c
      data eps/1.e-3/ pai/3.141592/ c0,ci/(0.,0.),(0.,1.)/
      write(6,*)'Program masw2_1.for'
c working folder name
	cwkf=cdrv//'maswkf/'
c parameter file
      filen='./maswkf/prm/'//'masw2_1.prm'
      write(6,'(a24)')filen
      open(11,file=filen,status='old')
c frequency range for analysis
      read(11,*)fmin,fmax,dt ! min. & max. of freq., sampling interval
      write(6,'(3f8.3,8x,a14)')fmin,fmax,dt,' :fmin,fmax,dt'
c file name for field data
      read(11,*)d_min,d_max  ! min. & max. of distance along measurement line
c                              for selection of CMPs
      write(6,'(2f8.1,16x,a13)')d_min,d_max,' :d_min,d_max'
      read(11,*)rrmin,rrmax,nbin ! min. & max. of spacing, size of cmp's group.
      write(6,'(2f8.1,i8,8x,a18)')rrmin,rrmax,nbin,
     *                                           ' :rrmin,rrmax,ngroup'
      read(11,*)min_stack,min_trace ! min. of stack & trace
      write(6,'(2i8,16x,a19)')min_stack,min_trace,' :min_stack & trace'
c Input files	==> Position of geophones(STA)
      read(11,*)nch,xm_line,dx,nd ! nch,measurement line length,interval,ndata
      write(6,'(i8,2f8.1,i8,a19)')nch,xm_line,dx,nd,
     *                         ' :nch,xm_line,dx,nd'
      if(nd.gt.nn0/2) then
       write(6,*)'ndata >',nn0/2,' Too big !'
       stop
      endif
      close(11)
      if(d_min.lt.eps) then
       write(6,*)'d_min = 0 is detected and resumed to the first CMP'
       d_min=dx/2.
       write(6,'(a8,f8.1)')' d_min =',d_min
      endif
c duration & frequency
      nn1=nd*2  !nn1
c
      if(nn1.gt. 256.and.nn1.le. 512) then
       nn1= 512
      else if(nn1.gt. 512.and.nn1.le.1024) then
       nn1=1024
      else if(nn1.gt.1024.and.nn1.le.2048) then
       nn1=2048
      else if(nn1.gt.2048.and.nn1.le.4096) then
       nn1=4096
      else if(nn1.gt.4096.and.nn1.le.8192) then
       nn1=8192
      else if(nn1.gt.8192) then
       write(6,*)'Too much samples in a file !'
       write(6,*)'It should be smaller than 4097.'
       stop
      endif
      nn=nn1/2          ! nd<nn<nn1=nn*2
c
      td=real(nn1)*dt
      do i=1,nn1
       fr(i)=real(i-1)/td
      enddo
      isf=int(fmin*td+0.5)+2
      ief=int(fmax*td+0.5)
c
      filen='./maswkf/prm/'//'geometry.prm'
      write(6,'(a25)')filen
      open(11,file=filen,status='old')
      read(11,*)
      read(11,*) nfile
c total number of common mid points
      ncmp=2*int(xm_line/dx+0.5)-1
      x_cmp_min=dx/2.
      x_cmp_max=real(ncmp)*dx/2.
c
      min_cmp=int(max(    0.,real(int(d_min*2./dx+0.5))))
      max_cmp=int(min(real(ncmp),real(int(d_max*2./dx))))
      write(6,*)'min_cmp=',min_cmp,'max_cmp=',max_cmp
      min_rr=int(max(      0., rrmin/dx)+0.5)
      if(min_rr.eq.0) min_rr=1
      max_rr=int(min(rrmax/dx,real(nch))    )
      write(6,*)'min_rr= ',min_rr,'max_rr= ',max_rr
c
      do ifile=1,nfile
       read(11,*)filnam(ifile),x_shot(ifile),x_1ch
c      write(6,'(4x,a12,2f8.1)')filnam(ifile),x_shot(ifile),x_1ch
c position of geophones(stations)
       x_sta(0,ifile)=999.999
       do ich=1,nch
        x_sta(ich,ifile)=x_1ch+real(ich-1)*dx
       enddo
      enddo ! loop(ifile) ends
   10 continue
c cleaning arrays nb_ch, nf_ch & cr
      do icmp=min_cmp,max_cmp
       do irr=min_rr,max_rr
        do ifile=1,nfile
         nb_ch(icmp,irr,ifile)=0
         nf_ch(icmp,irr,ifile)=0
        enddo
       enddo
      enddo
      do icmp=min_cmp,max_cmp
       x_cmp=real(icmp)*dx/2.
c       write(6,*)'icmp=',icmp,' x_cmp=',x_cmp
       do irr=min_rr,max_rr
        rrr=real(irr)*dx  
        x1=x_cmp-rrr/2.
        x2=x_cmp+rrr/2.
c       write(6,*)'icmp=',icmp,'x=',x_cmp,irr,rrr,x1,x2
cc
        do ifile=1,nfile
         x_b=9999.99
         x_f=9999.99
         if(x1-x_shot(ifile).ge.rrmin.and.
     *      x2-x_shot(ifile).ge.rrmin.and.
     *      x1-x_shot(ifile).le.rrmax.and.
     *      x2-x_shot(ifile).le.rrmax.and.
     *      x1.ge.0.) then
          x_b=x1
          x_f=x2
c         if(x2-x1.gt.22.*dx) write(6,*)icmp,irr,ifile,x_b,x_f,x2-x1
         else if(x_shot(ifile)-x1.ge.rrmin.and.
     *           x_shot(ifile)-x2.ge.rrmin.and.
     *           x_shot(ifile)-x1.le.rrmax.and.
     *           x_shot(ifile)-x2.le.rrmax.and.
     *           x2.le.xm_line) then
          x_b=x2
          x_f=x1
c         if(x2-x1.gt.22.*dx) write(6,*)icmp,irr,ifile,x_b,x_f,x2-x1
         else
          goto 40
         endif
c         write(6,*)'x1=',x1,'x_b=',x_b,' x_cmp=',x_cmp,
c     *                      ' x_f=',x_f,'x2=',x2,x2-x1
         do ich=1,nch
          if(abs(x_b-x_sta(ich,ifile)).lt.eps) then
           nb_ch(icmp,irr,ifile)=ich
           goto 20
          endif
         enddo
   20   continue
cc
         do ich=1,nch
          if(abs(x_f-x_sta(ich,ifile)).lt.eps) then
           nf_ch(icmp,irr,ifile)=ich
           goto 30
          endif
         enddo
   30	 continue
   40    continue
        enddo  ! loop(ifile) ends
       enddo   ! loop( irr ) ends
      enddo    ! loop(icmp ) ends
c count stack numbers
      do icmp=min_cmp,max_cmp
       do irr=min_rr,max_rr
        nstack(icmp,irr)=0
        do ifile=1,nfile 
         if(nb_ch(icmp,irr,ifile)*nf_ch(icmp,irr,ifile).ne.0) then
          nstack(icmp,irr)=nstack(icmp,irr)+1
         endif
        enddo
       enddo    
      enddo
c
      do icmp=min_cmp,max_cmp
       x_cmp=real(icmp)*dx/2.
c
       if(mod(icmp,25).eq.0) write(6,'(a18,i4,a1,i3)')
     *                        'Processed to icmp=',icmp,'/',max_cmp
c
       do irr=min_rr,max_rr
c cleaning array cr
        do i=1,nn0
         cr(i,icmp,irr)=0.0
        enddo
c
        do ifile=1,nfile 
         if(nb_ch(icmp,irr,ifile)*nf_ch(icmp,irr,ifile).ne.0) then
c         istack=istack+1
c open file(ifile) to extract the data of nb_ch and nf_ch
          filen='./maswkf/data/common_shot_gathers/'//filnam(ifile)
          open(1,file=filen,status='old')
          read(1,*)nch_,dt_,scale,nn_,cunit
c         write(6,*)ifile
          if(nch_.ne.nch) then
           write(6,*)'nch is not coincident'
           stop
          endif
          if(dt_.ne.dt) then
           write(6,*)'dt is not coincident'
           stop
          endif
          if(nn_.ne.nd) then
           write(6,*)'number of data is not coincident'
           stop
          endif
          read(1,*)comment
          do i=1,nd
           read(1,*)dum,(x(i,ich),ich=1,nch)
          enddo
          close(1)		 
          do i=1,nd
           f(i)=x(i,nf_ch(icmp,irr,ifile))
           g(i)=x(i,nb_ch(icmp,irr,ifile))
          enddo
c calculation of correrogram  frequency domain ===>  nn1=nn*2
c tapering
          call taper(f,nd,dt)
c zero padding
          do i=nd+1,nn1
	   f(i)=0.0
	  enddo
          do i=1,nn1
           cf(i)=cmplx(f(i),0.0)
          enddo
c Fourier Transform
          call cfft(cf,nn1,-1)
          cf(1)=c0
	  do i=2,nn1
	   cf(i)=cf(i)/real(nn1)*td
	  enddo
c tapering
	  call taper(g,nd,dt)
c zero padding
          do i=nd+1,nn1
	   g(i)=0.0
	  enddo
          do i=1,nn1
           cg(i)=cmplx(g(i),0.0)
          enddo
c Fourier Transform
          call cfft(cg,nn1,-1)
          cg(1)=c0
	  do i=2,nn1
	   cg(i)=cg(i)/real(nn1)*td
	  enddo
c cross-correlation of cf(i) and cg(i) in the frequency domain
          if(cmethod.eq.'CMPCC') then
           do i=1,nn1
            ch(i)=conjg(cg(i))*cf(i)	
           enddo
	  else if(cmethod.eq.'CMPCH') then
c complex coherence of cf(i) and cg(i) 
           ch(1)=c0
           do i=2,nn1
            ch(i)=conjg(cg(i))*cf(i)
     *                       /(cabs(cf(i))*cabs(cg(i)))
           enddo
	  else
           write(6,*)cmethod,' is not installed yet.'
	   stop
	  endif
c Inverse Fourier Transform ==> correlogram
          cf(1)=c0
	  do i=2,nn1
           cf(i)=ch(i)
          enddo
	  call cfft(cf,nn1,1)
          do i=1,nn1
           cr(i,icmp,irr)=cr(i,icmp,irr)+real(cf(i))
	  enddo
         endif
        enddo  ! loop(ifile) ends
c normalize the correlograms stacked over shots
        do i=1,nn1
         cr(i,icmp,irr)=cr(i,icmp,irr)/real(nstack(icmp,irr))
        enddo
       enddo    ! loop(irr) ends
      enddo    ! loop(icmp) ends
c stack over files for the icmp over cmp-bin.  time domain==>nn
      if(nbin.gt.-1) then
       do irr=min_rr,max_rr
c
        do icmp=min_cmp,max_cmp
         if(nstack(icmp,irr).gt.0) then
          do i=1,nn1
           cq1(i,icmp)=cr(i,icmp,irr)
          enddo
         else
          do i=1,nn1
           cq1(i,icmp)=0.
          enddo
         endif
         do i=1,nn1
          cq2(i,icmp)=0.
         enddo
         mstack(icmp,irr)=0
        enddo ! icmp
c
        do icmp=min_cmp+nbin,max_cmp-nbin,nbin*2+1
         istack=0
         do kcmp=-nbin,nbin
          if(nstack(icmp,irr).gt.0) then
          istack=istack+1
           do i=1,nn1
            cq2(i,icmp)=cq2(i,icmp)+cq1(i,icmp+kcmp)
           enddo
           mstack(icmp,irr)=mstack(icmp,irr)+nstack(icmp+kcmp,irr)
          endif
         enddo
         do i=1,nn1
          cq2(i,icmp)=cq2(i,icmp)/real(istack)
         enddo
        enddo  ! loop(icmp) ends
c
        do icmp=min_cmp,max_cmp
         do i=1,nn1
          cr(i,icmp,irr)=cq2(i,icmp)
         enddo
        enddo
c
       enddo   ! loop( irr) ends
      endif
c Output: CMP gather
      filen=cwkf//'data/geometry/cmp_geometry.dat'
      open(1,file=filen,status='unknown')
      do icmp=min_cmp+nbin,max_cmp-nbin,nbin*2+1
       x_cmp=real(icmp)*dx/2.
       if(icmp.lt.10) then 
	write(cfrm,'(a10)')'(a5,i1,a4)'
        write(filen,cfrm)'cmp00',icmp,'.dat'
       else if(icmp.ge.10.and.icmp.le.99) then
	write(cfrm,'(a10)')'(a4,i2,a4)'
        write(filen,cfrm)'cmp0',icmp,'.dat'
       else if(icmp.ge.100) then
	write(cfrm,'(a10)')'(a3,i3,a4)'
        write(filen,cfrm)'cmp',icmp,'.dat'
       endif
       n_trace=0
       do irr=min_rr,max_rr
        if(nstack(icmp,irr).ge.min_stack) then
         n_trace=n_trace+1
        endif
       enddo
       if(n_trace.ge.min_trace) then
        filen='./maswkf/data/cmp_gathers/'//filen
        open(13,file=filen,status='unknown')
        write(13,'(i8,2f8.4,2i8)')icmp,x_cmp,dt,nn,n_trace 
        write(6,*)filen
        write(1,*)filen(27:36)
        write(6,*)'Spacing ','   X1   ','   CMP  ',
     *                                '   X2   ','  Stack '
        write(1,*)'Spacing ','   X1   ','   CMP  ',
     *                                '   X2   ','  Stack '
        do irr=min_rr,max_rr
         rrr=real(irr)*dx
         x1=x_cmp-rrr/2.
         x2=x_cmp+rrr/2.
         if(mstack(icmp,irr).ge.min_stack) then
          write(1,'(4f8.3,i8)')rrr,x1,x_cmp,x2,mstack(icmp,irr)
          write(6,'(4f8.3,i8)')rrr,x1,x_cmp,x2,mstack(icmp,irr)
          write(13,'(i8,4f8.3,i8)')irr,rrr,x1,x_cmp,x2,mstack(icmp,irr)
          write(13,'(5e13.6)')(cr(i,icmp,irr),i=1,nn)
         endif
        enddo
        close(13)   
        write(1,*)
       endif
      enddo
      close(1)
c
      stop
      end
c+++++
      subroutine taper(x,n,dt)
      real x(n)
      data pai/3.141592/
      mwin=int(real(n)/20.+0.5)
c linear trend fitting
      b1=x(1)
      do i=2,n
       b1=b1+real(i)*x(i)
      enddo
      b2=x(1)
      do i=1,n
       b2=b2+x(i)
      enddo
      a0=real(n*(n+1)*(2*n+1))/6.*dt
      b0=real(n*(n+1))/2.
      c0=b0*dt
      d0=real(n)
      f0=a0*d0-b0*c0
      aa=( d0*b1-b0*b2)/f0
      bb=(-c0*b1+a0*b2)/f0
      do i=1,n
       x(i)=x(i)-aa*real(i)*dt-bb
      enddo
c tapering
      do i=1,mwin
       x(i)=x(i)*SIN(PAI/2.*REAL(i-1)/REAL(MWIN))
      enddo
      do i=n-mwin,n
       x(i)=x(i)*SIN(PAI/2.*REAL(n-i)/REAL(MWIN))
      enddo
      return
      end
c+++++
      SUBROUTINE CFFT(X,N,IND)
c...........................................................................
c
c     Complex Fast Fourier Transform
c
c     Coded by Y. OHSAKI in "Introduction to spectral analysis for
c                            seismic waves"
c     Typed by D.Suetsugu, IISEE
c     Modified by H.Inoue, IISEE
c
c     Usage.......   CALL FFT(N,X,IND)
c
c     where
c
c     X(N)    In/Out  Equi-spaced N complex data/Transformed values
c     N       In      Number of data, MUST be a power of 2.
c     IND     In      -1=Fourier transform,  1=Inverse Fourier transform
c
c     Note..... You must divide the output X() by N to get Fourier
c               coefficient when IND=-1.
c
c...........................................................................
      complex x(n),temp,theta
c
      j=1
      do 140 i=1,n
        if(i.ge.j) goto 110
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
  110   m=n/2
  120   if(j.le.m) goto 130
        j=j-m
        m=m/2
        if(m.ge.2) goto 120
  130   j=j+m
  140 continue
c  
      kmax=1
      do 150 kkk=1,9999
        if(kmax.ge.n) return
        istep=kmax*2
        do 170 k=1,kmax
          theta=cmplx(0.0,3.141593*float(ind*(k-1))/float(kmax))
          do 160 i=k,n,istep
            j=i+kmax
            temp=x(j)*cexp(theta)
            x(j)=x(i)-temp
            x(i)=x(i)+temp
  160     continue
  170   continue
        kmax=istep
  150 continue
      end
c+++++
      subroutine w_parzen(h,nn,n,dt,bw,g1,g2,n2,w,lmax0)
      real h(n),g1(n2),g2(n2),w(lmax0)
      data pai/3.141592/
c parzen window
      df=1./(dt*real(nn))
      udf=1.854305/bw*df
      if(udf.gt.0.5) then
       write(6,*)' Bandwidth is too narrow'
      endif
      lmax=int(2./udf+0.5)
      if(lmax.gt.lmax0) then
       write(6,*)'Bandwidth is too wide'
      endif
      w(1)=0.75*udf
      do l=2,lmax
       dif=pai/2.*real(l-1)*udf
       w(l)=w(1)*(sin(dif)/dif)**4
      enddo
      ll=lmax*2-1
      ln=ll-1+nn
      lt=(ll-1)*2+nn
      le=lt-lmax+1
      do k=1,lt
       g1(k)=0.
      enddo
      do k=1,nn
       g1(ll-1+k)=h(k)
      enddo
      do k=lmax,le
       s=w(1)*g1(k)
       do l=2,lmax
        s=s+w(l)*(g1(k-l+1)+g1(k+l-1))
       enddo
       g2(k)=s
      enddo
      do l=2,lmax
       g2(ll+l-1)=g2(ll+l-1)+g2(ll-l+1)
       g2(ln-l+1)=g2(ln-l+1)+g2(ln+l-1)
      enddo
      do k=1,nn
       h(k)=g2(ll-1+k)
      enddo
      return
      end

