      Program masw2cmp2D
c Multi-Channel Analysis of Surface Wave generated by an artificial 
c shot and measured along a line
c
c Multi-Channel + Multi-shot version for 2D analysis
c
c Major revision Mar.20,2019
c
c
      parameter(nn0=4096,nch0=24,nvl0=2000,lmax0=500,nfile0=250)
      complex ci,cf(nn0),crr(nn0,nch0),csum
      real aw(nn0,nvl0),awmax,cr(nn0,nch0)
      real  f(nn0),g(nn0),g1(nn0*2),g2(nn0*2),w(lmax0)
      real  fr(nn0),rr(nch0),
     *      y(nvl0),dy(nvl0),x_vel(100),aw_vel(100)
      character filen*80,finput*12,cmethod*5,cform*10,cdum*4,
     *          cdrv*2,cwkf*9,cnum*3,com1*80,cfile(nfile0)*10,
     *          cfile0*10,cini*4,cdm(2)*1,cfrm1*12
      data cdrv/'./'/ 
c     character cdrv*3,cwkf*10  
c     data cdrv/'../'/  
      cmethod='CMPCC'
      data pai/3.1415926/ c0,ci/(0.,0.),(0.,1.)/ eps/1.e-6/
      write(6,*)'        '
      write(6,'(a32)')'*****Program masw2cmp2D.for*****'
c working folder name
      cwkf=cdrv//'maswkf/'
c parameter file
      filen='./maswkf/prm/'//'masw2cmp.prm'
c     write(6,'(a50)')filen
      open(11,file=filen,status='old')
c frequency range for analysis
      read(11,*)fmin,fmax,dt,n_par
c     write(6,'(2f8.1,f8.3,i8)')fmin,fmax,dt,n_par
      read(11,*)n_cf_domain,normalize
c     write(6,'(2i8)')n_cf_domain,normalize
c file name for field data
      read(11,*)vmin,vmax,dv,ndisplay
      ndisplay=1
c     write(6,'(3f8.1,i8)')vmin,vmax,dv,ndisplay
      nvl=int((vmax-vmin)/dv+1)
      if(nvl.gt.nvl0) then
       write(6,*)' nvl.gt.nvl0'
       stop
      endif
c 
      filen='./maswkf/data/cmp_gathers/'//'cmpfile.lst'
      open(3,file=filen,status='old')
      do ifile=1,nfile0
       read(3,'(a10)',err=10,end=10) cfile(ifile)
       if(cfile(ifile).eq.'          ') goto 10
      enddo
   10 continue
      nfile=ifile-1
      ifile=1
      write(6,'(a5,a10,a2,a10,a4,a10,a3,i4,a22)') 'From ',cfile(1),
     *         ', ',cfile(2),' to ',cfile(nfile),' : ',nfile,
     *         ' CMP files are stored.'
      close(3)
c
      open(15,file='./maswkf/prm/cmpfcntl.prm',status='unknown') ! CMP file control
      read(15,'(i5,5x,a10)',err=12,end=12) ifile,cform
      read(15,*)ff1,fv1,ff2,fv2,ff3,fv3    ! lower limit'
      read(15,*)gg1,gv1,gg2,gv2,gg3,gv3    ! upper limit'
      go to 14
   12 rewind(15)                           ! new cmpfcntl.prm
      read(11,*)ff1,fv1,ff2,fv2,ff3,fv3	   ! lower limit, masw2cmp.prm
      read(11,*)gg1,gv1,gg2,gv2,gg3,gv3	   ! upper limit
      rewind(11)
      do kk=1,3                            ! skip 3 lines
       read(11,*)
      enddo
      ifile=1
      cform=cfile(ifile)
      write(15,'(i5,5x,a10)')ifile,cform
      write(15,'(6f7.1,a16)')ff1,fv1,ff2,fv2,ff3,fv3,' : ! lower limit'
      write(15,'(6f7.1,a16)')gg1,gv1,gg2,gv2,gg3,gv3,' : ! upper limit'
c                      ! same values in working memory and cmpfcntl.prm 
   14 close(15)
      write(6,'(a25,1x,a10,a2)')'The current CMP file is [ ',cform,' ]'
c
   22 write(6,*)'Select 1st parameter [c/j/n/p/e]; '
     *          //'2nd second [i/m/b/ ]. e.g.[c i],[n m] etc.'
c      write(6,*)'[c]: Process [current]   CMP with current C-F window'
c      write(6,*)'[j]: [jump] to specified CMP with current C-F window'
c      write(6,*)'[n]: Proceed to [next]   CMP with current C-F window'
c      write(6,*)'[p]: Back to [previous]  CMP with current C-F window'
c      write(6,*)'[e]: end/terminate the processing'
c      write(6,*)'Additional command (use as [c i], [n m] etc.)'
c      write(6,*)'[i]: [initialize] C-F win. with that of masw2cmp.prm'
c      write(6,*)'[m]: [modify] C-F win. by typing in the parameters'
c      write(6,*)'[b]: C-F win. used previously for the specified CMP'
c      write(6,*)'[ ]: Default: to use the current C-F window.'
      read(5,'(a12)')cfrm1
      do kk=1,12
       if(cfrm1(kk:kk).ne.' ') then
        kk1=kk
        cdm(1)=cfrm1(kk:kk)
        go to 24
       endif
      enddo
   24 continue
      do kk=kk1+1,12
       if(cfrm1(kk:kk).ne.' ') then
        kk2=kk
        cdm(2)=cfrm1(kk:kk)
        go to 25
       endif
      enddo
      cdm(2)=' '
   25 continue
c     write(6,'(a10,2a3)')'Selected: ',cdm(1),cdm(2)
c CFW:
      if(cdm(2).eq.'i')then       ! initialize CFW from masw2cmp.prm(11)
       read(11,*)ff1,fv1,ff2,fv2,ff3,fv3	    ! lower limit
       read(11,*)gg1,gv1,gg2,gv2,gg3,gv3	    ! upper limit
       write(6,*)'CFW initialized using the values in masw2cmp.prm.'
      else if(cdm(2).eq.'m')then  ! modify CFW with typed-in values (5)
       write(6,*)'Input the new parameters.'
       write(6,'(6f7.1,a16)') gg1,gv1,gg2,gv2,gg3,gv3,' : ! upper limit'
       read(5,*)              gg1,gv1,gg2,gv2,gg3,gv3     ! upper limit
       write(6,'(6f7.1,a16)') ff1,fv1,ff2,fv2,ff3,fv3,' : ! lower limit'
       read(5,*)              ff1,fv1,ff2,fv2,ff3,fv3	  ! lower limit
       write(6,*)'CFW renewed using the typed-in values.'
      else if(cdm(2).eq.' '.or.cdm(2).eq.'b') then ! default read from cmpfcntl.prm
       write(6,*)'CFW of the default values in cmpfcntl.prm.'
      else
       write(6,*)'Invalid input. Try again.'
       go to 22        
      endif
      open(15,file='./maswkf/prm/cmpfcntl.prm',status='unknown') ! CMP file control
      write(15,'(i5,5x,a10)')ifile,cform
      write(15,'(6f7.1,a16)')ff1,fv1,ff2,fv2,ff3,fv3,' : ! lower limit'
      write(15,'(6f7.1,a16)')gg1,gv1,gg2,gv2,gg3,gv3,' : ! upper limit'
      rewind(15)
      filen='./maswkf/prm/cmp_cntl/'//cform
      open(23,file=filen,status='unknown')
      write(23,'(i5,5x,a10)')ifile,cform
      write(23,'(6f7.1,a16)')ff1,fv1,ff2,fv2,ff3,fv3,' :lower limit'
      write(23,'(6f7.1,a16)')gg1,gv1,gg2,gv2,gg3,gv3,' :upper limit'
      close(23)
c-----
      if(cdm(1).eq.'c') then                      ! Process current CMP
       do ifile=1,nfile
        if(cform(1:10).eq.cfile(ifile)) goto 26
       enddo
   26  mfile0=ifile
c-----
      else if(cdm(1).eq.'j') then               ! Jump to specified CMP
   27  write(6,*)'Input CMP file name as cmp???.dat (a10)'
       read(5,'(a10)')cfile0
       do ifile=1,nfile
        if(cfile0.eq.cfile(ifile)) goto 30
       enddo
       write(6,*)cfile0,' cannot be found. Try again.'
       goto 27
   30  mfile0=ifile
c-----
      else if(cdm(1).eq.'n'.or.cdm(1).eq.'p') then ! to next or previous CMP
       read(15,'(i5)') mfile0
       rewind(15)
       if(cdm(1).eq.'n') then
        mfile0=mfile0+1                             ! to the next file
        if(mfile0.gt.nfile) then
         write(6,*)'Too big CMP number. Process terminated.'
         stop
        endif
       else if(cdm(1).eq.'p') then
        mfile0=mfile0-1                             ! to the previous file
        if(mfile0.lt.1) then
         write(6,*)'Too small CMP number. Process terminated.'
         stop
        endif
       endif
c-----
      else if(cdm(1).eq.'e') then                   ! end/terminate processing
       write(6,*)'Do you realy want to quit from the process?'//
     *                                     ' ENTER/[yes] or [no]'
       read(5,'(a2)')cdum
       if(cdum.ne.'no') then                       ! ending
        write(6,*)'Normal End'
        stop
       else
        goto 22
       endif
       stop
      else
       write(6,*)'Invalid input. Try again.'
       stop
      endif
c
      if(cdm(1).ne.'e') then
       if(cdm(2).eq.'b')then  ! C-F win. used previously for the specified CMP
        filen='./maswkf/prm/cmp_cntl/'//cfile(mfile0)
        open(23,file=filen,status='unknown')
        read(23,*)                                 ! skip
        read(23,*)ff1,fv1,ff2,fv2,ff3,fv3          !:lower limit
        read(23,*)gg1,gv1,gg2,gv2,gg3,gv3          !:upper limit
        close(23)
       endif
c
       write(15,'(i5,5x,a10)')mfile0,cfile(mfile0)
       write(15,'(6f7.1,a16)')ff1,fv1,ff2,fv2,ff3,fv3,' : ! lower limit'
       write(15,'(6f7.1,a16)')gg1,gv1,gg2,gv2,gg3,gv3,' : ! upper limit'
       rewind(15)
c
       filen='./maswkf/prm/cmp_cntl/'//cfile(mfile0)
       open(23,file=filen,status='unknown')
       write(23,'(i5,5x,a10)')mfile0,cfile(mfile0)
       write(23,'(6f7.1,a16)')ff1,fv1,ff2,fv2,ff3,fv3,' :lower limit'
       write(23,'(6f7.1,a16)')gg1,gv1,gg2,gv2,gg3,gv3,' :upper limit'
       close(23)
      endif
      close(15)
c temporary file   
      filen='./maswkf/temp/temp20.dat'
      open(20,file=filen,status='unknown')
      write(20,'(4(a5,3x))')'#    ','Freq.','Velo.','heigh'
      write(20,'(5x,3f8.3)')ff1,fv1,1.0
      write(20,'(5x,3f8.3)')ff2,fv2,1.0
      write(20,'(5x,3f8.3)')ff3,fv3,1.0
      write(20,'(5x,3f8.3)')gg3,gv3,0.0
      write(20,'(5x,3f8.3)')gg2,gv2,0.0
      write(20,'(5x,3f8.3)')gg1,gv1,0.0
      write(20,'(5x,3f8.3)')ff1,fv1,1.0
      close(20)
c    
      filen='./maswkf/prm/gnuplt_script/c_f_panels/'//'multi_cf.plt'
      open(8,file=filen,status='unknown')
c
       icmp=mfile0
       finput=cfile(icmp) 
       cnum=cfile(icmp)(4:6)
       filen='./maswkf/data/cmp_gathers/'//finput
       write(6,'(a36,a14)')filen,' (CMP gather) '
       open(13,file=filen,status='unknown')
       read(13,'(i8,2f8.4,i8)')icmp_,x_cmp,dt,nn
c      write(6,'(i8,2f8.4,i8)')icmp_,x_cmp,dt,nn
       do icase=1,nch0				! icase=i_spacing
        read(13,'(i8,4f8.3)',end=100)irr_,rr(icase),x1,x_cmp,x2
c       write(6,'(i8,4f8.3)')irr_,rr(icase),x1,x_cmp,x2
        read(13,'(5e13.6)')(cr(i,icase),i=1,nn)
       enddo
  100  ncase=icase-1
       close(13)    
c
       ndur=nn0/nn
       nn=nn*ndur
c duration & frequency
       td=real(nn)*dt
       do i=1,nn
        fr(i)=real(i-1)/td
       enddo
       isf=int(min(fmin,2.0)*td)+1
       ief=int(max(fmax,20.)*td)
c
       dx=rr(ncase)/real(ncase)
       dr=1.*dx
c
       do icase=1,ncase   
        do i=1,nn
         cf(i)=cr(i,icase)    
        enddo
        call cfft(cf,nn,-1)
c Parzen window
        if(n_par.ne.0) then
         bw=3.8/td
        endif
        do i=1,nn
         f(i)= real(cf(i))
         g(i)=aimag(cf(i))
        enddo
        if(bw.gt.1.e-6) then
         call w_parzen(f,nn,nn0,dt,bw,g1,g2,nn0*2,w,lmax0)
         call w_parzen(g,nn,nn0,dt,bw,g1,g2,nn0*2,w,lmax0)
        endif
        do i=1,nn
         cf(i)=cmplx(f(i),g(i))
        enddo
c
        do i=1,nn
         crr(i,icase)=cf(i)*td/real(nn)
        enddo
       enddo  ! loop(icase) ends
c
       if(cmethod.eq.'CMPCH') then
        do icase=1,ncase
         do i=1,nn
          crr(i,icase)=crr(i,icase)/cabs(crr(i,icase))
         enddo
        enddo
       endif
c conversion to c-f domain from r-f domain by stacking with phase lag correction.
       do i=1,nn0
        do ivl=1,nvl0
         aw(i,ivl)=0.0
        enddo
       enddo
       do i=isf,ief
        do ivl=1,nvl
         vl=vmin+(ivl-1)*dv
         rmd=vl/fr(i)
         ak=2.*pai/rmd
         csum=c0
         nsum=0
         do icase=1,ncase
          csum=csum+crr(i,icase)*exp(ci*ak*rr(icase))
          nsum=nsum+1
         enddo
         aw(i,ivl)=real(csum)
        enddo
       enddo
       awmax=aw(i,1)
       do i=isf,ief
        do ivl=2,nvl
         if(awmax.lt.aw(i,ivl)) awmax=aw(i,ivl)
        enddo
       enddo
       do i=isf,ief
        do ivl=1,nvl
         aw(i,ivl)=aw(i,ivl)/awmax
         if(aw(i,ivl).lt.0.) aw(i,ivl)=0.
        enddo
       enddo
c
       if(normalize.eq.1) then
        do i=isf,ief
         awmax=aw(i,1)
         do ivl=2,nvl
          if(awmax.lt.aw(i,ivl)) awmax=aw(i,ivl)
         enddo
         do ivl=1,nvl
          if(awmax.gt.eps) then
           aw(i,ivl)=aw(i,ivl)/awmax
          else
           aw(i,ivl)=0.
          endif
         enddo
        enddo
       endif
c intermediate output: c-f domain
       if(n_cf_domain.ne.0) then
        if(cmethod.eq.'CMPCC') then
         filen='./maswkf/data/c_f_panels/'//'crs_cf'//cnum//'.dat'
        else if(cmethod.eq.'CMPCH') then
         filen='./maswkf/data/c_f_panels/'//'coh_cf'//cnum//'.dat'
        endif
c       write(6,'(a50)')filen
        open(2,file=filen,status='unknown')
        filen='./maswkf/data/c_f_panels/'//'coh_pk'//cnum//'.dat'
c       write(6,'(a50)')filen
        open(22,file=filen,status='unknown')
        write(2,'(a1,7x,a8,2(8x,a8),3i5)')
     *        '#',' Freq.  ','  Vel.  ',' C-F Sp.',isf,ief,nvl
        write(22,'(a1,7x,a8,2(8x,a8),3i5)')
     *        '#',' Freq.  ','  Vel.  ',' C-F Sp.',isf,ief,nvl
        filen='./maswkf/temp/temp33.dat'
        open(33,file=filen,status='unknown')
        write(33,'(a1,7x,a8,2(8x,a8))')
     *        '#',' Freq.  ','  Vel.  ',' C-F Sp.'
c
        do i=isf,ief
         do ivl=1,nvl
          write(2,*)fr(i),vmin+(ivl-1)*dv,aw(i,ivl)
         enddo
         write(2,*)
        enddo
        close(2)
       endif
c output file
       finput='cmp'//cnum//'ds.dat'
       filen='./maswkf/data/dispersion/'//finput
c      write(6,'(a50)')filen
       open(12,file=filen,status='unknown')
       write(12,'(2(1x,a8))')
     *        '#  Freq.',' V.m/s  '
c determination of phase velocity
       isf=int(fmin*td)+1
       ief=int(fmax*td)
       do i=isf,ief
        if(fr(i).ge.fmin.and.fr(i).le.fmax) then
c
         if(fr(i).lt.ff1) then
          fvmin=fv1
         else if(ff1.le.fr(i).and.fr(i).lt.ff2) then
          fvmin=(fv2-fv1)*(fr(i)-ff1)/(ff2-ff1)+fv1
         else if(ff2.le.fr(i).and.fr(i).lt.ff3) then
          fvmin=(fv3-fv2)*(fr(i)-ff2)/(ff3-ff2)+fv2
         else if(ff3.le.fr(i)) then
          fvmin=fv3
         endif
         if(fr(i).lt.gg1) then
          fvmax=gv1
         else if(gg1.le.fr(i).and.fr(i).lt.gg2) then
          fvmax=(gv2-gv1)*(fr(i)-gg1)/(gg2-gg1)+gv1
         else if(gg2.le.fr(i).and.fr(i).lt.gg3) then
          fvmax=(gv3-gv2)*(fr(i)-gg2)/(gg3-gg2)+gv2
         else if(gg3.le.fr(i)) then
          fvmax=gv3
         endif
         do ivl=1,nvl
          y(ivl)=aw(i,ivl)
         enddo
c differenciation over velocity
         do ivl=1,nvl-1
          dy(ivl)=(y(ivl+1)-y(ivl))/dv
         enddo
c search local maximum
         n_max=0
         do ivl=2,nvl
          if(dy(ivl).lt.0..and.dy(ivl-1).gt.0.) then
           ramda=(vmin+real(ivl-1)*dv)/fr(i)
           if(ramda.ge.2.*dr.and.ramda.le.4.*rr(ncase)) then
            xvel=vmin+real(ivl-1)*dv
            if(xvel.gt.fvmin.and.xvel.lt.fvmax.and.
     *       fr(i).gt.max(ff1,gg1).and.fr(i).lt.min(ff3,gg3)) then
             n_max=n_max+1
             x_vel(n_max)=xvel
             aw_vel(n_max)=y(ivl)
             write(22,*)fr(i),x_vel(n_max),y(ivl)  ! coh_pk???.dat
            else
             write(33,*)fr(i),xvel,y(ivl)  ! coh_pk???.dat / temp33.dat
            endif 
           endif
          endif
         enddo  ! loop(ivl) ends
         if(n_max.le.8) then              ! dispersion/cmp???ds.dat
          write(cform,'(a1,i1,a5)') '(',n_max+1,'f9.3)'
          if(n_max.gt.0) then 
           write(12,cform(1:7) )fr(i),(x_vel(i_max),i_max=1,n_max)
          endif
         else if(n_max.le.98) then
          write(cform,'(a1,i2,a5)') '(',n_max+1,'f9.3)'
          write(12,cform(1:8) )fr(i),(x_vel(i_max),i_max=1,n_max)
         endif
c
        endif
       enddo  ! loop(i) ends
c
       close(12)
       close(11)
c graphic output using GNUPLOT
       filen='./maswkf/prm/geometry.prm'
       open(11,file=filen,status='old')
c      write(6,'(a50)')filen
       read(11,'(a45)')com1
c      write(6,'(a45)')com1
       close(11)
       filen='./maswkf/prm/gnuplt_script/c_f_panels/masw'//cnum//'.plt'
c      write(6,'(a50)')filen
       open(12,file=filen,status='unknown')
       write(12,*)'reset'
       write(12,*)'unset key'
       write(12,*)'set palette rgbformulae 30,31,32'
       if(ndisplay.eq.1) then
        write(12,*)'# Graph title'
        write(12,*)'set title "'//com1(1:45)//': CMP#'//cnum//' "'
        write(12,*)'# Horizontal axis: label & range'
        write(12,*)'set xlabel "Frequency (Hz)"'
        write(12,*)'set xrange [',fmin,':',fmax,']'
        write(12,*)'# Verical axis: label & range'
        write(12,*)'set ylabel "Phase Velocity (m/s)"'
        write(12,*)'set yrange [',vmin,':',vmax,']'
        write(12,*)'set grid'
        write(12,*)'# C-F spectra '
        write(12,*)'set zrange [0:1]'
        write(12,*)'#'
        write(12,*)'set pm3d map'
        write(12,*)'set multiplot'
      write(12,*)'splot "./maswkf/data/c_f_panels/crs_cf'//cnum//'.dat"'
      write(12,*)'splot "./maswkf/data/c_f_panels/coh_pk'//cnum//'.dat"'
     *                      //' with points pt 1 ps 1 lc "#ffa500" lw 2'  ! Orange +
      write(12,*)'splot "./maswkf/temp/temp33.dat"'
     *                      //' with points pt 1 ps 1 lc "#5e0117" lw 2'  ! DarkScarlet +
      write(12,*)'splot "./maswkf/temp/temp20.dat" with linespoints'
     *           //' lc "#ffffff"'
       write(12,*)'unset multiplot'
       endif
c
       write(12,*)'set terminal postscript color enhanced'
       write(12,*)
     *     'set output "./maswkf/data/c_f_panels/fig/cmp'//cnum//'.ps"'
       write(12,*)'# Graph title'
       write(12,*)'set title "'//com1(1:45)//': CMP#'//cnum//' "'
       write(12,*)'# Horizontal axis: label & range'
       write(12,*)'set xlabel "Frequency (Hz)"'
       write(12,*)'set xrange [',fmin,':',fmax,']'
       write(12,*)'# Verical axis: label & range'
       write(12,*)'set ylabel "Phase Velocity (m/s)"'
       write(12,*)'set yrange [',vmin,':',vmax,']'
       write(12,*)'set grid'
       write(12,*)'# C-F spectra '
       write(12,*)'set zrange [0:1]'
       write(12,*)'#'
       write(12,*)'set pm3d map'
       write(12,*)'set multiplot'
      write(12,*)'splot "./maswkf/data/c_f_panels/crs_cf'//cnum//'.dat"'
      write(12,*)'splot "./maswkf/data/c_f_panels/coh_pk'//cnum//'.dat"'
     *                      //' with points pt 1 ps 1 lc "#ffa500" lw 2'
      write(12,*)'splot "./maswkf/temp/temp33.dat"'
     *                      //' with points pt 1 ps 1 lc "#5e0117" lw 2'  ! DarkScarlet +
      write(12,*)'splot "./maswkf/temp/temp20.dat" with linespoints'
     *           //' lc "#ffffff"'
       write(12,*)'unset multiplot'
       write(12,*)'set output'
       write(12,*)'set terminal x11'
       close(12)
c 
       write(8,*)
     * 'load ''./maswkf/prm/gnuplt_script/c_f_panels/masw',cnum,'.plt'''
c
      write(8,*)'pause -1 "[ENTER] to continue "'
c 
      close(8)
      stop
      end
c+++++
      subroutine peak_rms(x,n,judge,ac)
      real x(n)
c peak value
c      write(6,*)'peak_rms'
	amx=abs(x(1))
	do i=2,n
	 if(amx.lt.abs(x(i))) amx=abs(x(i))
	enddo
c rms value
      sum=0.0
      do i=1,n
       sum=sum+x(i)**2
	enddo
      rms=sqrt(sum/real(n))
c judge
      judge=1
      if(amx.gt.rms*ac) judge=0
	return
	end
c+++++
      subroutine taper(x,n,dt)
      real x(n)
      data pai/3.141592/
      mwin=int(real(n)/20.+0.5)
c linear trend fitting
      b1=x(1)
      do i=2,n
       b1=b1+real(i)*x(i)
      enddo
      b2=x(1)
      do i=1,n
       b2=b2+x(i)
      enddo
      a0=real(n*(n+1)*(2*n+1))/6.*dt
      b0=real(n*(n+1))/2.
      c0=b0*dt
      d0=real(n)
      f0=a0*d0-b0*c0
      aa=( d0*b1-b0*b2)/f0
      bb=(-c0*b1+a0*b2)/f0
      do i=1,n
       x(i)=x(i)-aa*real(i)*dt-bb
      enddo
c tapering
      do i=1,mwin
       x(i)=x(i)*SIN(PAI/2.*REAL(i-1)/REAL(MWIN))
      enddo
      do i=n-mwin,n
       x(i)=x(i)*SIN(PAI/2.*REAL(n-i)/REAL(MWIN))
      enddo
      return
      end
c+++++
      SUBROUTINE CFFT(X,N,IND)
c...........................................................................
c
c     Complex Fast Fourier Transform
c
c     Coded by Y. OHSAKI in "Introduction to spectral analysis for
c                            seismic waves"
c     Typed by D.Suetsugu, IISEE
c     Modified by H.Inoue, IISEE
c
c     Usage.......   CALL FFT(N,X,IND)
c
c     where
c
c     X(N)    In/Out  Equi-spaced N complex data/Transformed values
c     N       In      Number of data, MUST be a power of 2.
c     IND     In      -1=Fourier transform,  1=Inverse Fourier transform
c
c     Note..... You must divide the output X() by N to get Fourier
c               coefficient when IND=-1.
c
c...........................................................................
      complex x(n),temp,theta
c
      j=1
      do 140 i=1,n
        if(i.ge.j) goto 110
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
  110   m=n/2
  120   if(j.le.m) goto 130
        j=j-m
        m=m/2
        if(m.ge.2) goto 120
  130   j=j+m
  140 continue
c  
      kmax=1
      do 150 kkk=1,9999
        if(kmax.ge.n) return
        istep=kmax*2
        do 170 k=1,kmax
          theta=cmplx(0.0,3.141593*float(ind*(k-1))/float(kmax))
          do 160 i=k,n,istep
            j=i+kmax
            temp=x(j)*cexp(theta)
            x(j)=x(i)-temp
            x(i)=x(i)+temp
  160     continue
  170   continue
        kmax=istep
  150 continue
      end
c+++++
      subroutine w_parzen(h,nn,n,dt,bw,g1,g2,n2,w,lmax0)
      real h(n),g1(n2),g2(n2),w(lmax0)
      data pai/3.141592/
c parzen window
      df=1./(dt*real(nn))
      udf=1.854305/bw*df
      if(udf.gt.0.5) then
       write(6,*)' Bandwidth is too narrow'
      endif
      lmax=int(2./udf+0.5)
      if(lmax.gt.lmax0) then
       write(6,*)'Bandwidth is too wide'
      endif
      w(1)=0.75*udf
      do l=2,lmax
       dif=pai/2.*real(l-1)*udf
       w(l)=w(1)*(sin(dif)/dif)**4
      enddo
      ll=lmax*2-1
      ln=ll-1+nn
      lt=(ll-1)*2+nn
      le=lt-lmax+1
      do k=1,lt
       g1(k)=0.
      enddo
      do k=1,nn
       g1(ll-1+k)=h(k)
      enddo
      do k=lmax,le
       s=w(1)*g1(k)
       do l=2,lmax
        s=s+w(l)*(g1(k-l+1)+g1(k+l-1))
       enddo
       g2(k)=s
      enddo
      do l=2,lmax
       g2(ll+l-1)=g2(ll+l-1)+g2(ll-l+1)
       g2(ln-l+1)=g2(ln-l+1)+g2(ln+l-1)
      enddo
      do k=1,nn
       h(k)=g2(ll-1+k)
      enddo
      return
      end

